////////////////////////////////////////////////////////////////////////////////
//:  Ը 
//e-mail: urvanovf@hotmail.ru
//: http://www.dxgames.narod.ru
////////////////////////////////////////////////////////////////////////////////

#include "cglstdafx.h"
#include "cglframe.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CGLFrame::CGLFrame(GLint p_nGraphQuality)
{


	GLfloat f=CGL_PI/p_nGraphQuality;
	GLfloat b,x,y,z,a;
	GLint n,m,k;
	CGLVertex** pfLevels;//   

	m_nGraphQuality=p_nGraphQuality;

	m_nCountVertex=0;
	m_nCountIndex=0;
	m=0;
	for (n=1; n<=p_nGraphQuality;n++)
	{
		b=f*n;
		x=sinf(b);
		a=1.0f/x*f;
		k=(cpputils::Round(CGL_2PI/a+0.5+2));
		m_nCountVertex+=k;
		m_nCountIndex+=k*3+m*3;
		m=k;
	}
	m_nCountVertex+=2;//    .

	b=f*1;
	x=sinf(b);
	a=1.0f/x*f;
	m_nCountIndex+=3*(cpputils::Round(CGL_2PI/a+0.5+2))*2;

	m_Vertices=new CGLVertex[m_nCountVertex];
	if (!m_Vertices) throw 1;
	pfLevels=new CGLVertex*[p_nGraphQuality+1];
	if (!pfLevels) throw 1;


	///////////////////////////////////
	//  
	m_Vertices[0].m_Vertex.x=0;
	m_Vertices[0].m_Vertex.y=1.0f;
	m_Vertices[0].m_Vertex.z=0;
	m_Vertices[0].m_Normal.z=0.0f;
	m_Vertices[0].m_Normal.y=1.0f;
	m_Vertices[0].m_Normal.x=0.0f;
	m_Vertices[0].m_Color.r=1.0f;
	m_Vertices[0].m_Color.g=1.0f;
	m_Vertices[0].m_Color.b=1.0f;
	m_Vertices[0].m_Color.a=1.0f;
	pfLevels[0]=&m_Vertices[0];
	k=1;
	for (n=1; n<p_nGraphQuality;n++)
	{
		b=f*n;
		x=sin(b);
		y=cos(b);
		a=1.0f/x*f;
		GLfloat cf;
		pfLevels[n]=&m_Vertices[k];//  
		for (m=0;m<=CGL_2PI/a;m++)
		{
			cf=a*m;
			z=sin(b)*sin(cf);
			x=sin(b)*cos(cf);
			m_Vertices[k].m_Vertex.x=x;
			m_Vertices[k].m_Vertex.y=y;
			m_Vertices[k].m_Vertex.z=z;
			m_Vertices[k].m_Normal.z=z;
			m_Vertices[k].m_Normal.y=y;
			m_Vertices[k].m_Normal.x=x;
			m_Vertices[k].m_Color.r=1.0f;
			m_Vertices[k].m_Color.g=1.0f;
			m_Vertices[k].m_Color.b=1.0f;
			m_Vertices[k].m_Color.a=1.0f;
			k++;
		}
	}

	//for (m=0; m<n;m++)
//	{
//		pfLevels[m+n]=m_Vertices-pfLevels[m+n-1]+pfLevels[n-m];
//	}
//	n=pfLevels[n-1]-m_Vertices;
//	for (m=0;m<n;m++)
//	{
//		m_Vertices[k].m_Vertex.x=m_Vertices[m].m_Vertex.x;
//		m_Vertices[k].m_Vertex.z=m_Vertices[m].m_Vertex.z;
//		m_Vertices[k].m_Vertex.y=-m_Vertices[m].m_Vertex.y;
//		m_Vertices[k].m_Normal=m_Vertices[k].m_Vertex;
//		k++;
//	}

	m_Vertices[k].m_Vertex.x=0.0f;
	m_Vertices[k].m_Vertex.y=-1.0f;
	m_Vertices[k].m_Vertex.z=0.0f;
	m_Vertices[k].m_Normal.z=0.0f;
	m_Vertices[k].m_Normal.y=-1.0f;
	m_Vertices[k].m_Normal.x=0.0f;
	m_Vertices[k].m_Color.r=1.0f;
	m_Vertices[k].m_Color.g=1.0f;
	m_Vertices[k].m_Color.b=1.0f;
	pfLevels[p_nGraphQuality]=&m_Vertices[k];
	m_Vertices[k].m_Color.a=1.0f;
	m_nCountVertex=k+1;

	/////////////////////////////////////////////////////////////////
	GLint i=0,j,startk,startm,lastk;
	GLfloat hypotenuse1,hypotenuse2;
	m_unIndices=new GLuint[m_nCountIndex];
	for (n=1; n<=p_nGraphQuality/2+p_nGraphQuality%2;n++)
	//for (n=2; n<7;n++)
	{
		//  
		m=pfLevels[n]-m_Vertices+1;
		k=pfLevels[n-1]-m_Vertices;
		startk=k;
		startm=m;
		CGLVector3 *p=&(m_Vertices[m-1].m_Vertex);
		hypotenuse1=sqrt(p->x*p->x+p->z*p->z);
		p=&(m_Vertices[k].m_Vertex);
		hypotenuse2=sqrt(p->x*p->x+p->z*p->z);
		while (&m_Vertices[m]!=pfLevels[n+1])
		{
			a=acos((m_Vertices[m-1].m_Vertex.x)/hypotenuse1);
			b=acos((m_Vertices[k].m_Vertex.x)/hypotenuse2);
			if (cpputils::GetSign(m_Vertices[m-1].m_Vertex.z)==-1)
			{
				a=CGL_PI+CGL_PI-a;

			}
			if (cpputils::GetSign(m_Vertices[k].m_Vertex.z)==-1)
			{
				b=CGL_PI+CGL_PI-b;
			}
			if (a>b)
			{
				lastk=k;
				if (&(m_Vertices[k+1])!=(CGLVertex*)(startm))
					k++;
				else
					k=startk;
				m_unIndices[i]=k;
				m_unIndices[i+1]=m-1;
				m_unIndices[i+2]=lastk;
				i+=3;

			}

			m_unIndices[i]=m;
			m_unIndices[i+1]=m-1;
			m_unIndices[i+2]=k;
			i+=3;
			m++;
		}
		m_unIndices[i]=pfLevels[n]-m_Vertices;
		m_unIndices[i+1]=m-1;
		m_unIndices[i+2]=k;

		i+=3;
//i=0;
		if (n>=2)
		{
			int nEnd=pfLevels[n]-m_Vertices-1;
			m_unIndices[i]=startk;
			m_unIndices[i+1]=startm-1;
			m_unIndices[i+2]=nEnd;
			i+=3;
			if (nEnd!=k)
			{
				m_unIndices[i]=k+1;
				m_unIndices[i+1]=startm-1;
				m_unIndices[i+2]=k;
				i+=3;
			}
		}

	}


	for (j=0;j<=i;j++)
	{
		m_unIndices[j+i]=m_nCountVertex-m_unIndices[j]-1;

	}
	m_nCountIndex=i*2;
	delete [] pfLevels;

};


void CGLFrame::SetSphereChange(GLfloat p_fx,GLfloat p_fy,GLfloat p_fz,GLfloat p_fRadius)
{


	GLint n;
	GLfloat fLength,fDiv;
	GLfloat fx,fy,fz;
	for (n=0; n<m_nCountVertex; n++)
	{
		fx=m_Vertices[n].m_Vertex.x-p_fx;
		fy=m_Vertices[n].m_Vertex.y-p_fy;
		fz=m_Vertices[n].m_Vertex.z-p_fz;
		fLength=sqrt(fx*fx+fy*fy+fz*fz);
		if (fLength<=p_fRadius)
		{
			fDiv=p_fRadius/fLength;
			fx=fx*fDiv;
			fy=fy*fDiv;
			fz=fz*fDiv;
			m_Vertices[n].m_Vertex.x=p_fx+fx;
			m_Vertices[n].m_Vertex.y=p_fy+fy;
			m_Vertices[n].m_Vertex.z=p_fz+fz;
			m_Vertices[n].m_Normal.x=fx;
			m_Vertices[n].m_Normal.y=fy;
			m_Vertices[n].m_Normal.z=fz;
			m_Vertices[n].m_Normal.Normalize();
			/*for (m=0;m<m_nCountIndex;m++)
			{
				if (m==n)
				{
					GLint k=m%3;
					switch (k)
					{
					case 0:
						m_Vertices[m+1].m_Normal=m_Vertices[m+1].m_Normal+m_Vertices[n].m_Normal;
						m_Vertices[m+1].m_Normal.Normalize();
						m_Vertices[m+2].m_Normal=m_Vertices[m+2].m_Normal+m_Vertices[n].m_Normal;
						m_Vertices[m+2].m_Normal.Normalize();
						break;
					case 1:
						m_Vertices[m-1].m_Normal=m_Vertices[m-1].m_Normal+m_Vertices[n].m_Normal;
						m_Vertices[m-1].m_Normal.Normalize();
						m_Vertices[m+1].m_Normal=m_Vertices[m+1].m_Normal+m_Vertices[n].m_Normal;
						m_Vertices[m+1].m_Normal.Normalize();
						break;
					case 2:
						m_Vertices[m-2].m_Normal=m_Vertices[m-2].m_Normal+m_Vertices[n].m_Normal;
						m_Vertices[m-2].m_Normal.Normalize();
						m_Vertices[m-1].m_Normal=m_Vertices[m-1].m_Normal+m_Vertices[n].m_Normal;
						m_Vertices[m-1].m_Normal.Normalize();
						break;
					}
				}
			}*/

		}

	}
}


void CGLFrame::SetSphereColor(GLfloat p_fx,GLfloat p_fy, GLfloat p_fz,GLfloat p_fRadius,const CGLColor& p_Color)
{

	GLint n;
	GLfloat fLength;
	GLfloat fx,fy,fz;
	for (n=0; n<m_nCountVertex; n++)
	{
		fx=m_Vertices[n].m_Vertex.x-p_fx;
		fy=m_Vertices[n].m_Vertex.y-p_fy;
		fz=m_Vertices[n].m_Vertex.z-p_fz;
		fLength=sqrt(fx*fx+fy*fy+fz*fz);
		if (fLength<=p_fRadius)
		{
			m_Vertices[n].m_Color.r=p_Color.r*(fLength/p_fRadius);
			m_Vertices[n].m_Color.g=p_Color.g*(fLength/p_fRadius);
			m_Vertices[n].m_Color.b=p_Color.b*(fLength/p_fRadius);
		}

	}
}
void CGLFrame::SetLinearChange(
		GLfloat p_fStartx,GLfloat p_fStarty,GLfloat p_fStartz,GLfloat p_fStartRadius,
		GLfloat p_fEndx,GLfloat p_fEndy,GLfloat p_fEndz,GLfloat p_fEndRadius)
{
	GLfloat current=0.0;
	GLfloat fsx=p_fEndx-p_fStartx,fsy=p_fEndy-p_fStarty,fsz=p_fEndz-p_fStartz;
	GLfloat fsRadius=p_fEndRadius-p_fStartRadius;
	GLfloat fGraphQuality=(GLfloat)m_nGraphQuality;
	GLfloat fStep=sqrt((fsx*fsx)+(fsy*fsy)+(fsz*fsz))/fGraphQuality/4;
	GLfloat fRadius,fx,fy,fz;

	while (current<=1.0)
	{
		fx=p_fStartx+(fsx)*current;
		fy=p_fStarty+(fsy)*current;
		fz=p_fStartz+(fsz)*current;
		fRadius=p_fStartRadius+fsRadius*current;
		SetSphereChange(fx,fy,fz,fRadius);
		current+=fStep;
	}
}


void CGLFrame::SetLinearColor(
		GLfloat p_fStartx,GLfloat p_fStarty,GLfloat p_fStartz,GLfloat p_fStartRadius,const CGLColor & p_StartColor,
		GLfloat p_fEndx,GLfloat p_fEndy,GLfloat p_fEndz,GLfloat p_fEndRadius,const CGLColor& p_EndColor)
{
	GLfloat current=0.0;
	GLfloat fsx=p_fEndx-p_fStartx,fsy=p_fEndy-p_fStarty,fsz=p_fEndz-p_fStartz;
	GLfloat fsRadius=p_fEndRadius-p_fStartRadius;
	GLfloat fGraphQuality=(GLfloat)m_nGraphQuality;
	GLfloat fStep=sqrt((fsx*fsx)+(fsy*fsy)+(fsz+fsz))/fGraphQuality/4;
	GLfloat fRadius,fx,fy,fz;

	CGLColor Color;
	GLfloat fr=p_EndColor.r-p_StartColor.r,
			fg=p_EndColor.g-p_StartColor.g,
			fb=p_EndColor.b-p_StartColor.b,
			fa=p_EndColor.a-p_StartColor.a;
	while (current<=1.0)
	{
		fx=p_fStartx+(fsx)*current;
		fy=p_fStarty+(fsy)*current;
		fz=p_fStartz+(fsz)*current;
		Color.r=p_StartColor.r+fr*current;
		Color.g=p_StartColor.g+fg*current;
		Color.b=p_StartColor.b+fb*current;
		Color.a=p_StartColor.a+fa*current;
		fRadius=p_fStartRadius+fsRadius*current;
		SetSphereColor(fx,fy,fz,fRadius,Color);
		current+=fStep;
	}
}
CGLFrame::~CGLFrame()
{
	delete []m_Vertices;
	delete []m_unIndices;
}

void CGLFrame::SetShininess(GLfloat p_fShininess)
{
	m_fShininess=p_fShininess;
}
GLfloat CGLFrame::GetShininess(void)
{
	return m_fShininess;
}



void CGLFrame::SetParentPoint(GLfloat p_fx,GLfloat p_fy,GLfloat p_fz)
{
	m_Parent.x=p_fx;
	m_Parent.y=p_fy;
	m_Parent.z=p_fz;
}

const CGLVector3 &  CGLFrame::GetParentPoint(void)
{
	return m_Parent;
}
